org.apache.tinkerpop.gremlin.process.traversal.step.util

## Class ReducingBarrierStep<S,E>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,E>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.util.ReducingBarrierStep<S,E>

- All Implemented Interfaces:
    Serializable, Cloneable, Iterator<Traverser.Admin<E>>, Step<S,E>, Barrier<E>, Generating<E,E>, MemoryComputing<E>
  Direct Known Subclasses:
    CountGlobalStep, FoldStep, GroupCountStep, GroupStep, MaxGlobalStep, MeanGlobalStep, MinGlobalStep, SumGlobalStep, TreeStep

      public abstract class ReducingBarrierStep<S,E>
      extends AbstractStep<S,E>
      implements Barrier<E>, Generating<E,E>

  Author:
    Marko A. Rodriguez (http://markorodriguez.com)
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected BinaryOperator<E>` | `reducingBiOperator`
    `protected Supplier<E>` | `seedSupplier`

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ReducingBarrierStep(Traversal.Admin traversal)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addBarrier(E barrier)` Add a barrier to the step.
    `ReducingBarrierStep<S,E>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `void` | `done()` A way to hard set that the barrier is complete.
    `BinaryOperator<E>` | `getBiOperator()`
    `MemoryComputeKey<E>` | `getMemoryComputeKey()` The `MemoryComputeKey` that will be used by this step.
    `Supplier<E>` | `getSeedSupplier()`
    `boolean` | `hasNextBarrier()` Whether or not the step has an accessible barrier.
    `E` | `nextBarrier()` Get the next barrier within this step.
    `void` | `processAllStarts()` Process all left traversers by do not yield the resultant output.
    `Traverser.Admin<E>` | `processNextStart()`
    `abstract E` | `projectTraverser(Traverser.Admin<S> traverser)`
    `void` | `reset()` Reset the state of the step such that it has no incoming starts.
    `void` | `setReducingBiOperator(BinaryOperator<E> reducingBiOperator)`
    `void` | `setSeedSupplier(Supplier<E> seedSupplier)`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getStarts, getTraversal, hashCode, hasNext, hasStarts, isTraverserStepIdAndLabelsSetByChild, next, prepareTraversalForNextStep, removeLabel, setId, setNextStep, setPreviousStep, setTraversal, toString`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Generating

      `generateFinalResult`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals, getRequirements`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Field Detail

    - #### seedSupplier

          protected Supplier<E> seedSupplier

    - #### reducingBiOperator

          protected BinaryOperator<E> reducingBiOperator

  - ### Constructor Detail

    - #### ReducingBarrierStep

          public ReducingBarrierStep(Traversal.Admin traversal)

  - ### Method Detail

    - #### setSeedSupplier

          public void setSeedSupplier(Supplier<E> seedSupplier)

    - #### getSeedSupplier

          public Supplier<E> getSeedSupplier()

    - #### projectTraverser

          public abstract E projectTraverser(Traverser.Admin<S> traverser)

    - #### setReducingBiOperator

          public void setReducingBiOperator(BinaryOperator<E> reducingBiOperator)

    - #### getBiOperator

          public BinaryOperator<E> getBiOperator()

    - #### reset

          public void reset()

      Description copied from interface: `Step`
      Reset the state of the step such that it has no incoming starts. Internal states are to be reset, but any sideEffect data structures are not to be recreated.
      Specified by:
        `reset` in interface `Step<S,E>`
      Overrides:
        `reset` in class `AbstractStep<S,E>`

    - #### done

          public void done()

      Description copied from interface: `Barrier`
      A way to hard set that the barrier is complete. This is necessary when parallel barriers don't all have barriers and need hard resetting. The default implementation does nothing.
      Specified by:
        `done` in interface `Barrier<E>`

    - #### processAllStarts

          public void processAllStarts()

      Description copied from interface: `Barrier`
      Process all left traversers by do not yield the resultant output. This method is useful for steps like `ReducingBarrierStep`, where traversers can be processed "on the fly" and thus, reduce memory consumption.
      Specified by:
        `processAllStarts` in interface `Barrier<E>`

    - #### hasNextBarrier

          public boolean hasNextBarrier()

      Description copied from interface: `Barrier`
      Whether or not the step has an accessible barrier.
      Specified by:
        `hasNextBarrier` in interface `Barrier<E>`
      Returns:
        whether a barrier exists or not

    - #### nextBarrier

          public E nextBarrier()

      Description copied from interface: `Barrier`
      Get the next barrier within this step. Barriers from parallel steps can be the be merged to create a single step with merge barriers.
      Specified by:
        `nextBarrier` in interface `Barrier<E>`
      Returns:
        the next barrier of the step

    - #### addBarrier

          public void addBarrier(E barrier)

      Description copied from interface: `Barrier`
      Add a barrier to the step. This typically happens when multiple parallel barriers need to become one barrier at a single step.
      Specified by:
        `addBarrier` in interface `Barrier<E>`
      Parameters:
        `barrier` - the barrier to merge in

    - #### processNextStart

          public Traverser.Admin<E> processNextStart()

      Specified by:
        `processNextStart` in class `AbstractStep<S,E>`

    - #### clone

          public ReducingBarrierStep<S,E> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<S,E>`
      Overrides:
        `clone` in class `AbstractStep<S,E>`
      Returns:
        The cloned step

    - #### getMemoryComputeKey

          public MemoryComputeKey<E> getMemoryComputeKey()

      Description copied from interface: `MemoryComputing`
      The `MemoryComputeKey` that will be used by this step.
      Specified by:
        `getMemoryComputeKey` in interface `MemoryComputing<E>`
      Returns:
        the MemoryComputeKey to use

Copyright © 2013–2021 Apache Software Foundation. All rights reserved.